var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();
var active_playlist = 2;
var current_playlist = 2;
var playlists_shown = true;
var bars_shown = false;
var channel_info_shown = false;
var current_videos;
var tips;
var timer;
var vid_index = 0;
var exit = 0;
var focusButton = 2;
var connection_popup_shown = false;
var Main =
{

};


Main.onLoad = function()
{
	loadTips();
	window.onShow = onShowEvent;
	
	// Enable key event processing
	
	widgetAPI.sendReadyEvent();
	setInterval(cyclicInternetConnectionCheck, 2000);

};

Main.onUnload = function()
{
	alert('bye');
};

onShowEvent = function() {
	 NNaviPlugin = document.getElementById("pluginObjectNNavi");
	    
	    alert("[APPS] : setBannerstate : 1");
	    PL_NNAVI_STATE_BANNER_NONE = 0;
	    PL_NNAVI_STATE_BANNER_VOL = 1;
	    PL_NNAVI_STATE_BANNER_VOL_CH = 2;
	    
	    NNaviPlugin.SetBannerState(PL_NNAVI_STATE_BANNER_VOL);
	    pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	    pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	    pluginAPI.unregistKey(tvKey.KEY_MUTE);
};

Main.keyDown = function()
{
	var keyCode = event.keyCode;
	alert("Key pressed: " + keyCode);
	ytplayer = document.getElementById("ytPlayer");
	
	switch(keyCode)
	{
		case tvKey.KEY_RETURN:
		case tvKey.KEY_PANEL_RETURN:
		case tvKey.KEY_EXIT:
		case tvKey.KEY_PANEL_EXIT:
			alert("RETURN");
			document.getElementById("exit_dialog").style.display= "block";
			document.getElementById("anchorPopup").focus();
			widgetAPI.blockNavigation(event);
			if (keyCode == tvKey.KEY_EXIT) {
				exit = 1;
			} else {
				exit = 0;
			}
			ytPlayer.pauseVideo();
			break;
		case tvKey.KEY_LEFT:
			alert("LEFT");
			if (playlists_shown) {
				if (active_playlist > 1) {
					active_playlist--;
					$(".playlist").removeClass("active");
					$(".playlist:eq(" + (active_playlist-1) + ")").addClass("active");
					$("#playlists").css("left", "+=307");
					
				}
			} else {
				if (vid_index <= 0) {
					vid_index = (current_videos["ids"]).length - 1;
				} else {
					vid_index--;
				}
				ytPlayer.loadVideoById(current_videos["ids"][vid_index]);
			}
			break;
		case tvKey.KEY_RIGHT:
			alert("RIGHT");
			if (playlists_shown) {
				if (active_playlist < 6) {
					active_playlist++;
					$(".playlist").removeClass("active");
					$(".playlist:eq(" + (active_playlist-1) + ")").addClass("active");
					$("#playlists").css("left", "-=307");
				}
			} else {
				if (vid_index >= ((current_videos["ids"]).length - 1)) {
					vid_index  = 0;
				} else {
					vid_index++;
				}
				ytPlayer.loadVideoById(current_videos["ids"][vid_index]);
			}
			break;
		case tvKey.KEY_UP:
			alert("UP");
			break;
		case tvKey.KEY_DOWN:
			alert("DOWN");
			break;
		case tvKey.KEY_ENTER:
		case tvKey.KEY_PANEL_ENTER:
			alert("ENTER");
			if (playlists_shown) {
				togglePlaylists();
				if (current_playlist != active_playlist) {
					loadVideos($(".playlist.active").data('pid'));
					current_playlist = active_playlist;
				}
			} else {
				state = ytPlayer.getPlayerState();
				if (state == 2) {
					ytPlayer.playVideo();
				} else {
					ytPlayer.pauseVideo();
					pluginAPI.setOnScreenSaver(300);
				}
			}
			break;
		case tvKey.KEY_INFO:
				toggleBars();
				hideVideoInfo();
			break;
		case tvKey.KEY_RED:
			alert("RED");
			togglePlaylists();
			break;
	}
};

Main.keyDownPopup = function()
{
	var keyCode = event.keyCode;
	alert("Key pressed Popup: " + keyCode);
	switch(keyCode)
	{
		case tvKey.KEY_ENTER:
		case tvKey.KEY_PANEL_ENTER:
			alert("P_ENTER");
			if (focusButton == "1") {
				if (!exit) {
					widgetAPI.sendReturnEvent();
				} else {
					widgetAPI.sendExitEvent();
				}
			} else {
				document.getElementById("exit_dialog").style.display= "none";
				document.getElementById("anchor").focus();
				ytplayer = document.getElementById("ytPlayer");
				ytPlayer.playVideo();
			}
			break;
		case tvKey.KEY_LEFT:
			alert("P_LEFT");
			document.getElementById("button1").style.backgroundColor="#ffffff";
			document.getElementById("button2").style.backgroundColor="#3000ff";
			focusButton = "1";
			break;
			
		case tvKey.KEY_RIGHT:
			alert("P_RIGHT");
			document.getElementById("button1").style.backgroundColor="#3000ff";
			document.getElementById("button2").style.backgroundColor="#ffffff";
			focusButton = "2";
			break;
		
		case tvKey.KEY_EXIT:
		case tvKey.KEY_RETURN:
		case tvKey.KEY_PANEL_RETURN:
			widgetAPI.blockNavigation(event);
			alert("P_RETURN");
			document.getElementById("exit_dialog").style.display= "none";
			document.getElementById("anchor").focus();
			ytPlayer.playVideo();
			break;
	}
};

function loadTips() {
	$.ajax({
		url: "http://origin-www.fashiontv.com/smarttv/ajax.php", 
		data: {tips: true},
		type: 'GET',
		dataType: 'jsonp',
		success: function(result){
			tips = result.tips;
		}
	});
}

// This function gets videos list for specific playlist
function loadVideos(plid)
{
	$.ajax({
		url: "http://origin-www.fashiontv.com/smarttv/ajax.php", 
		data: {ytpl: plid},
		type: 'GET',
		dataType: 'jsonp',
		success: function(result){
			current_videos = result.videos;
			ytplayer = document.getElementById("ytPlayer");
			vid_index = 0;
		    ytPlayer.loadVideoById(current_videos["ids"][0]);
		    $("#top_bar .channel_name").html($(".playlist.active .video_name").html());
		    $("#top_bar .channel_name").css("color", $(".playlist.active").data("color"));
		    $("#top_bar").css("border-bottom-color", $(".playlist.active").data("color"));
		    $(".now_playing_title").css("background-color", $(".playlist.active").data("color"));
		    $("#channel_image").css("background-image", "url(images/channels_popups/" +  $(".playlist.active").data("pid") + ".png)");
		}
	});
	return 1;
}

//This function is called when youtube player initialized
function onYouTubePlayerReady(playerId)
{
	ytplayer = document.getElementById("ytPlayer");
	ytPlayer.setVolume(50);
	ytPlayer.setLoop(true);
	loadVideos($(".playlist.active").data('pid'));
	ytplayer.addEventListener("onStateChange", "onPlayerStateChange");
	ytplayer.addEventListener("onError", "onPlayerError");
}

//This function is called when an error is thrown by the player
function onPlayerError(errorCode)
{
	alert("An error occured of type:" + errorCode);
}

// This function is called when the player changes state
function onPlayerStateChange(newState)
{
	if(newState == '1') {
		updateTitles();
		$("#splash").hide();
		$("#buffer").hide();
		timer = window.setTimeout(showVideoInfo, 10000);
		pluginAPI.setOffScreenSaver();
		document.getElementById("anchor").focus();
	}
	if (newState != 1 && newState != 2) {
		document.getElementById("anchorEmpty").focus();
	}
	if(newState == '-1') {
		$("#tip").html(tips["tip" + Math.ceil(Math.random() * 10)]);
		$("#buffer").show();
		hideVideoInfo();
		if (bars_shown) {
			toggleBars();
		}
	}
	if(newState == '0') {
		if (vid_index >= ((current_videos["ids"]).length - 1)) {
			vid_index  = 0;
		} else {
			vid_index++;
		}
		ytPlayer.loadVideoById(current_videos["ids"][vid_index]);
	}
}

// This function updates the title of the current video in all places
function updateTitles()
{
	ytplayer = document.getElementById("ytPlayer");
	current_title = current_videos['titles'][vid_index];
	current_t_title = current_videos['t_titles'][vid_index];
	$("#now_playing .now_playing_title").html(current_title);
	$("#top_bar .video_title").html(current_t_title);
}

//This function shows or hides playlist thumbs and buttons at bottom bar
function togglePlaylists()
{
	if (bars_shown) {
		$("#top_bar").hide();
		$("#bottom_bar").hide();
		$(".control_buttons").hide();
		bars_shown = false;
	}
	if (playlists_shown) {
		$("#playlists").hide();
		$("#bottom_bar").hide();
		$(".playlists_buttons").hide();
	} else {
		$("#playlists").show();
		$("#bottom_bar").show();
		$(".playlists_buttons").show();
		hideVideoInfo();
	}
	playlists_shown = !playlists_shown;
}

//This function shows or hides the top and bottom bars
function toggleBars()
{
	if (playlists_shown) {
		$("#playlists").hide();
		$("#bottom_bar").hide();
		$(".playlists_buttons").hide();
		playlists_shown = false;
	}
	if (bars_shown) {
		$("#bottom_bar").hide();
		$("#top_bar").hide();
		$(".control_buttons").hide();
	} else {
		$("#bottom_bar").show();
		$("#top_bar").show();
		$(".control_buttons").show();
	}
	bars_shown = !bars_shown;
}

//This function shows the 'now playing' info
function showVideoInfo()
{
	ytplayer = document.getElementById("ytPlayer");
	seconds = ytplayer.getCurrentTime();
	if (!channel_info_shown && !playlists_shown && seconds > 7) {
		channel_info_shown = true;
		$("#channel_image").show();
		$("#now_playing").show();
		$("#top_bar").hide();
		$("#bottom_bar").hide();
		bars_shown = false;
	}
	
	window.setTimeout(hideVideoInfo, 10000);
	
}

//This function hides the 'now playing' info
function hideVideoInfo() {
	channel_info_shown = false;
	$("#channel_image").hide();
	$("#now_playing").hide();
	window.clearTimeout(timer);
}

//This function shows/hides the 'no connetion' popup if there is no network connection
function cyclicInternetConnectionCheck() {
	ytplayer = document.getElementById("ytPlayer");
    if(!checkConnection() ){
            // no internet connection

            if(!connection_popup_shown){
            	connection_popup_shown = true;
            	ytplayer.pauseVideo();
            	document.getElementById("noconnectionpopup").style.display="block";
            	document.getElementById("anchorEmpty").focus();
            }
    } else {
            // if error message was shown, it should be returned back to normal

            if(connection_popup_shown) {
            	ytplayer.playVideo();
            	document.getElementById("anchor").focus();
            	document.getElementById("noconnectionpopup").style.display="none";
            	connection_popup_shown = false;
                    // return to normal screen
            	
            }
    }
}

//This function checks the network connection
function checkConnection() {
    var physicalConnection = 0;
    var networkPlugin  = document.getElementById("pluginObjectNetwork");
    var httpStatus = 0;

    // Get active connection type - wired or wireless.
    currentInterface = networkPlugin.GetActiveType();

    // If no active connection.
    if (currentInterface === -1) {
            return false;
    }

    // Check physical connection of current interface.
    physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface);

    // If not connected or error.
    if (physicalConnection !== 1) {
            return false;
    }

    // Check HTTP transport.
    httpStatus = networkPlugin.CheckHTTP(currentInterface);

    // If HTTP is not avaliable.
    if (httpStatus !== 1) {
            return false;
    }

    // Everything went OK.
    return true;
}